#
#  blcutout.cl (available in noao.imred.irred)
#

procedure       blcutout( imlist, output, coords, xmag, ymag, ncols, nlines, outlist )

file    imlist          {prompt = "Input image list with @ mark"}
file    output          {prompt = "Output image"}
file    coords          {prompt = "Input coordinate list (block64.tbl/block128.tbl)"}
real    xmag            {prompt = "X output pixels per input pixel"}
real    ymag            {prompt = "Y output pixels per input pixel"}
int     ncols           {prompt = "Number of columns in the output image"}
int     nlines          {prompt = "Number of lines in the output image"}
file    outlist         {prompt = "List of output images"}

struct  *list1    {mode = 'h'}
struct  *list2    {mode = 'h'}
struct  *list3    {mode = 'h'}
#
#
begin
        string  tmpfile1, tmpfile1_2 , tmpfile2, tmpfile3

        string  junk1, junk2

        string  filelist1

        string  tmpimage1, tmpimage2, tmpimage3, tmpimage4

        string  output1, coords1

        string  outlist1

        int     i

        real    x_mag, y_mag

        real    x, y, x_in, y_in

        output1 = output
        coords1 = coords
        outlist1 = outlist

        filelist1 = imlist
        tmpfile2 = mktemp( "tmp_file." )
# ---- Image Name or Image List with @ mark ?
        sections( filelist1, option='fullname', > tmpfile2 )
        list2 = tmpfile2

        list3 = ""
        tmpfile3  = mktemp( "tmp_file." )
        x_mag = 1/xmag
        y_mag = 1/ymag
        i = 0

        while( fscan( list2, junk1 ) == 1 ) 
            {
           list1 = coords1
            while( fscan ( list1, x, y, ) != EOF )
                {
                    i = i + 1
                    delete( tmpfile3,ver-,>&"dev$null" )
                    if(i<10) print( output1,".00",i, >> tmpfile3 )
                    else if(i<100) print( output1,".0",i, >> tmpfile3 )
                    else print( output1,".",i, >> tmpfile3 )
                    list3 = tmpfile3
                    print( list3, >> outlist1 )
                    list3 = tmpfile3
                    if( fscan( list3, junk2 ) == 1){
                        tmpfile1  = mktemp( "tmp_file." )
                        tmpfile1_2 = mktemp( "tmp_file." )
                        tmpimage1 = mktemp( "tmp_im." )
                        tmpimage2 = mktemp( "tmp_im." )
                        tmpimage3 = mktemp( "tmp_im." )
                        tmpimage4 = mktemp( "tmp_im." )
                        x_in=x
                        y_in=y
        imlintran( junk1, tmpimage1, 0., 0., x_mag, y_mag, xin=x_in, yin=y_in, xout=1., yout=1., ncols=ncols, nlines=nlines, interpo="linear", fluxcon+ )
                        x_in=x+512
                        y_in=y
        imlintran( junk1, tmpimage2, 0., 0., x_mag, y_mag, xin=x_in, yin=y_in, xout=1., yout=1., ncols=ncols, nlines=nlines, interpo="linear", fluxcon+ )
                        x_in=x
                        y_in=y+512
        imlintran( junk1, tmpimage3, 0., 0., x_mag, y_mag, xin=x_in, yin=y_in, xout=1., yout=1., ncols=ncols, nlines=nlines, interpo="linear", fluxcon+ )
                        x_in=x+512
                        y_in=y+512
        imlintran( junk1, tmpimage4, 0., 0., x_mag, y_mag, xin=x_in, yin=y_in, xout=1., yout=1., ncols=ncols, nlines=nlines, interpo="linear", fluxcon+ )
                        print( tmpimage1, >> tmpfile1 )
                        print( tmpimage2, >> tmpfile1 )
                        print( tmpimage3, >> tmpfile1 )
                        print( tmpimage4, >> tmpfile1 )
                        irmosaic( "@"//tmpfile1, junk2, tmpfile1_2, 2, 2, nxoverl=0, nyoverl=0)
                        imdelete( "@"//tmpfile1 )
                        delete( tmpfile1,ver-,>&"dev$null" )
                        delete( tmpfile1_2,ver-,>&"dev$null" )
                        }
                  }
            }
        delete( tmpfile2,ver-,>&"dev$null" )
        delete( tmpfile3,ver-,>&"dev$null" )
        bye
end
