#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#define MAXDATA 1024
#define MAXCHAR 1024

main(int argc,char *argv[])
{
  int i,j;
  int ii;
  int imax1,imax2,timax;
  int iimax;
  int iloop;
  int jmin[MAXDATA];
  double x1[MAXDATA],y1[MAXDATA],x2[MAXDATA],y2[MAXDATA];
  double bx1[MAXDATA],by1[MAXDATA],bx2[MAXDATA],by2[MAXDATA];
  double tx2[MAXDATA],ty2[MAXDATA];
  double fx1[MAXDATA],fy1[MAXDATA],fx2[MAXDATA],fy2[MAXDATA];
  double vecx,vecy;
  double d,dmin;
  double dlimit=1e-3;
  double dx,dy,ddx,ddy;
  FILE *fp;
  char line[MAXCHAR];
  double searchmax, tmpsearchmax;
  int nloop;

  int counter;

  if(argc != 4){
    fprintf(stderr,"Usage: matchpat file1 file2 max_radius\n");
    exit(0);
  }
  
  searchmax=20.0;
  sscanf(argv[3],"%lf",&searchmax);
  /*  fprintf(stderr,"%lf\n",searchmax); */

  /* Load Data */
  if((fp = fopen(argv[1],"r")) == NULL){
    fprintf(stderr,"Cannot open %s\n",argv[1]);
    exit(1);
  }
  i=0;
  while(fgets(line,MAXCHAR,fp)!=NULL){
    if(strncmp(line,"#",1)){
      sscanf(line,"%lf %lf",&bx1[i],&by1[i]);
      i++;
    }
  }
  imax1=i;
  fclose(fp);
  
  if((fp = fopen(argv[2],"r")) == NULL){ 
    fprintf(stderr,"Cannot open %s\n",argv[2]);
    exit(1);
  }
  i=0;
  while(fgets(line,MAXCHAR,fp)!=NULL){
    if(strncmp(line,"#",1)){
      sscanf(line,"%lf %lf",&bx2[i],&by2[i]);
      i++;
    }
  }
  imax2=i;
  fclose(fp);

  fprintf(stderr,"# NR  %d %d\n",imax1, imax2); 
  if( imax1 > 0 && imax2 > 0 ){
    /* backup initial data */
    for(i=0;i<imax1;i++){
      x1[i]=bx1[i];
      y1[i]=by1[i];
    }
    for(i=0;i<imax2;i++){
      x2[i]=bx2[i];
      y2[i]=by2[i];
    }
    
    /* START */
    /* move all the x1/y1 data into fx1/fy1 */
    for(i=0;i<imax1;i++){
      fx1[i]=bx1[i];
      fy1[i]=by1[i];
    }
    /* move all the x2/y2 data into tx2/ty2 */
    for(i=0;i<imax2;i++){
      tx2[i]=bx2[i];
      ty2[i]=by2[i];
    }
    
    /* start loop for pattern matching -- 1 */
    dx=0;dy=0;
    ddx=dlimit*2;ddy=dlimit*2;
    iloop=0;
    
    iimax=imax1;
    timax=imax2;

    while(fabs(ddx)>dlimit || fabs(ddy)>dlimit && imax1 > 0 && imax2 > 0){
      /* fprintf(stderr,"ddx=%f\tddy=%f\n",ddx,ddy); */
      /*            fprintf(stderr,"# iteration\n");  */
      
      /* Pattern Matching */
      ii=0;  
      for(i=0;i<iimax;i++){
	/* fprintf(stderr,"%d,%lf,%lf\n",i,bx1[i],by1[i]); */
	dmin=1e20;
	counter=0;
	for(j=0;j<timax;j++){
	  d=(fx1[i]-tx2[j])*(fx1[i]-tx2[j])+(fy1[i]-ty2[j])*(fy1[i]-ty2[j]);
	  /* if any point find within searchmax */
	  if(d<searchmax*searchmax){
	    /*  	 fprintf(stderr,"# match1: \t %02d (%.2f %.2f) <-> %02d (%.2f %.2f)\n",i,fx1[i],fy1[i],j,tx2[j],ty2[j]);   */
	    counter++;
	    if(d<dmin){
	      dmin=d;
	      jmin[i]=j;
	    }
	  }
	}
	
	/* if only one object found within searchmax */
	if(counter==1){
	  vecx+=((fx1[i]-tx2[jmin[i]])/((double) timax));
	  vecy+=((fy1[i]-ty2[jmin[i]])/((double) timax));
	  /* new array for x1 and x2*/
	  x1[ii]=fx1[i];
	  y1[ii]=fy1[i];
	  /* pair array for x1 and x2*/
	  x2[ii]=tx2[jmin[i]];
	  y2[ii]=ty2[jmin[i]];
	  /*	  	  fprintf(stderr,"# match2: %d\t(%.2f %.2f) <-> (%.2f %.2f)\n",ii,x1[ii],y1[ii],x2[ii],y2[ii]);     */
	  ii++;
	}
	/*      if(counter>1){
		fprintf(stderr,"%d objects found within search radius %f\n",counter,searchmax);
		}  */
	
      }
      iimax=ii;
      timax=ii;
      
      /* move all the revised array into fx1/fy1 */
      for(i=0;i<iimax;i++){
	fx1[i]=x1[i];
	fy1[i]=y1[i];
	tx2[i]=x2[i];
	ty2[i]=y2[i];
      }
      
      /* Calculate Minimum dx,dy*/
      ddx=0;ddy=0;
      for(i=0;i<iimax;i++){
	/*      fprintf(stderr,"%lf,%lf\t%lf,%lf\n",vecx,vecy,fx2[i],fy2[i]); */
	ddx+=(fx1[i]-tx2[i])/((double) iimax);
	ddy+=(fy1[i]-ty2[i])/((double) iimax);
      }
      dx+=ddx;
      dy+=ddy;
      iloop++;
      /*    fprintf(stderr,"%d  dx=%.2f dy=%.2f %f %f\n",iimax,dx,dy,ddx,ddy);   */
      
      /* add ddx and ddy obtained in previous loop */
      for(i=0;i<timax;i++){
	tx2[i]+=ddx;
	ty2[i]+=ddy;
      }
      
    }
  }

  nloop=0;
  tmpsearchmax=searchmax;
  while( iimax == 0 && tmpsearchmax < 3*searchmax ){
    if( iimax == 0  && imax1 > 0 && imax2 > 0 ){
      fprintf(stderr,"# Start loop %d, iimax=%d imax1=%d imax2=%d\n",nloop,iimax,imax1,imax2);
      /* No object matches, start loop for pattern matching */
      
      /* increase the maximum search radius */
      /* tmpsearchmax+=searchmax; */
      tmpsearchmax+=5;
      
      /* move all the x1/y1 data into fx1/fy1 */
      for(i=0;i<imax1;i++){
	fx1[i]=bx1[i];
	fy1[i]=by1[i];
      }
      /* move all the x2/y2 data into tx2/ty2 */
      for(i=0;i<imax2;i++){
	tx2[i]=bx2[i];
	ty2[i]=by2[i];
      }
      
      dx=0;dy=0;
      ddx=dlimit*2;ddy=dlimit*2;
      iloop=0;
      
      timax=imax2;
      iimax=imax1;
      
      while(fabs(ddx)>dlimit || fabs(ddy)>dlimit){
	/*    fprintf(stderr,"ddx=%f\tddy=%f\n",ddx,ddy); */

	/* Pattern Matching */
	ii=0;  
	for(i=0;i<iimax;i++){
	  /* fprintf(stderr,"%d,%lf,%lf\n",i,x1[i],y1[i]); */
	  dmin=1e20;
	  counter=0;
	  for(j=0;j<timax;j++){
	    d=(fx1[i]-tx2[j])*(fx1[i]-tx2[j])+(fy1[i]-ty2[j])*(fy1[i]-ty2[j]);
	    /* if any point find within searchmax */
	    if(d<dmin){
	      dmin=d;
	      jmin[i]=j;
	    }
	    if(d<tmpsearchmax*tmpsearchmax){
	      counter++;
	    }
	  }
	  
	  /* if only one object found within searchmax */
	  if(counter==1){
	    vecx+=((fx1[i]-tx2[jmin[i]])/((double) timax));
	    vecy+=((fy1[i]-ty2[jmin[i]])/((double) timax));
	    /* new array for x1 and x2*/
	    x1[ii]=fx1[i];
	    y1[ii]=fy1[i];
	    /* pair array for x1 and x2*/
	    fx2[ii]=tx2[jmin[i]];
	    fy2[ii]=ty2[jmin[i]];
	    ii++;
	  }
	  /*      if(counter>1){
		  fprintf(stderr,"%d objects found within search radius %f\n",counter,searchmax);
		  }  */
	  
	}
	iimax=ii;
	timax=ii;
	
	/* move all the revised array into fx1/fy1 */
	for(i=0;i<iimax;i++){
	  fx1[i]=x1[i];
	  fy1[i]=y1[i];
	  tx2[i]=fx2[i];
	  ty2[i]=fy2[i];
	}
	
	/* Calculate Minimum dx,dy*/
	ddx=0;ddy=0;
	for(i=0;i<iimax;i++){
	  /*      fprintf(stderr,"%lf,%lf\t%lf,%lf\n",vecx,vecy,fx2[i],fy2[i]); */
	  ddx+=(fx1[i]-fx2[i])/((double) iimax);
	  ddy+=(fy1[i]-fy2[i])/((double) iimax);
	}
	dx+=ddx;
	dy+=ddy;
	iloop++;
	/*    fprintf(stderr,"%d  dx=%.2f dy=%.2f %f %f\n",iimax,dx,dy,ddx,ddy);   */
	
	/* add ddx and ddy obtained in previous loop */
	for(i=0;i<timax;i++){
	  tx2[i]+=ddx;
	  ty2[i]+=ddy;
	}
      }
    }
    if(iimax > 0) {
      fprintf(stderr,"Search radius=%.1f : ",tmpsearchmax);
      break;
    }
    nloop++;
  }

  if( imax1 > 0 && imax2 > 0 ){
    fprintf(stderr,"Used %d points for matching;  Offset: x=%lf\ty=%lf\n",iimax,dx,dy);
  }
  else{
    fprintf(stderr,"No points available for for matching\n");
  }
  fprintf(stdout,"%lf\t%lf\n",dx,dy);
}
